#include "bits/stdc++.h"

using namespace std;
using ll = long long;

ll mod = 998244353;

ll mul(ll a, ll b) {
    return (a*b)%mod;
}

ll binpow(ll a, ll b) {
    if (b == 0) return 1;
    if (b == 1) return a % mod;
    ll x = binpow(mul(a, a), b/2);
    if (b % 2 == 0) return x;
    return mul(x, a);
}

ll rev(ll x) {
    return binpow(x, mod-2);
}

ll k;
ll fun(ll n) {
    return mul((binpow(k-1, n+1) + binpow(-1, n)) % mod, rev(k));
}

void fix(pair<int, int> &p, int n) {
    p.first = (p.first + n) % n;
    p.second = (p.second + n) % n;
    if (p.first > p.second)
        swap(p.first, p.second);
}

ll calc(vector<pair<int, int>> &v, int l, int r, int n) {
    sort(v.begin() + l, v.begin() + r);
    if (l == r) {
        return fun(n-2);
    }
    auto[a, b] = v[l];
    int m = l;
    while (m < r && v[m].second <= b)
        m++;

    for (int i = l+1; i < m; i++) {
        v[i].first -= a;
        v[i].second -= a;
        fix(v[i], n);
    }
    for (int i = m; i < r; i++) {
        v[i].first -= b;
        v[i].second -= b;
        fix(v[i], n);
    }
    ll x1 = calc(v, l+1, m, b-a+1);
    ll x2 = calc(v, m, r, n-b+a+1);
    return mul(x1, x2);
}

void solve() {
    int n, m; cin >> n >> m >> k;
    vector<pair<int, int>> v(m);
    for (auto&[a, b] : v) {
        cin >> a >> b;
        a--, b--;
        if (a > b)
            swap(a, b);
    }
    sort(v.begin(), v.end());
    ll ans = calc(v, 0, v.size(), n);
    ans = mul(mul(ans, k), k-1);
    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);
    int t; cin >> t;
    for (int i = 0; i < t; i++)
        solve();
}
