import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        var scanner = new Scanner(System.in);

        int tests = scanner.nextInt();
        int n;

        var result = new int[tests];

        for (int k = 0; k < tests; k++) {
            n = scanner.nextInt();

            int threshold = -1;
            int minToChange = Integer.MAX_VALUE;
            int maxDiff = 0;
            boolean invalid = false;

            var currentHeights = new int[n];

            for (int i = 0; i < n; i++) {
                currentHeights[i] = scanner.nextInt();
            }

            for (int i = 0; i < n; i++) {
                int oldHeight = scanner.nextInt();

                if (invalid) {
                    continue;
                }

                if (oldHeight == currentHeights[i]) {
                    threshold = Math.max(threshold, oldHeight);
                } else if (currentHeights[i] > oldHeight) {
                    invalid = true;
                } else {
                    minToChange = Math.min(minToChange, currentHeights[i]);
                    maxDiff = Math.max(maxDiff, oldHeight - currentHeights[i]);
                }

                if (minToChange < threshold) {
                    invalid = true;
                }
            }

            if (invalid) {
                result[k] = -1;
            } else {
                result[k] = maxDiff;
            }
        }

        for (var elem : result) {
            System.out.println(elem);
        }
    }
}

/*
4
4
3 2 4 2
5 3 6 2
1
10
100000
5
1 2 3 4 5
1 2 3 4 5
3
1 4 6
4 1 8
 */

/*
7
2
0 2
1 7
1
4
1
2
0 2
1 2
3
1 1 3
1 2 3
2
1 0
1 1
3
1 3 3
1 4 3
3
1 2 3
1 4 3
 */