#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;

void solve() {
    int n; cin >> n;
    vector<int> h(n); for (int &x : h) cin >> x;
    vector<int> p(n); for (int &x : p) cin >> x;

    int H = *max_element(p.begin(), p.end()) + 1;

    map<int, int> mxr;
    map<int, int> lbound;
    map<int, int> ubound;
    set<int> pts;

    for (int i = 0; i < n; i++) {
        if (h[i] > p[i]) {
            cout << -1 << '\n'; return;
        }
        if (h[i] < p[i]) {
            mxr[h[i] + 1] = max(mxr[h[i] + 1], p[i] + 1);
            pts.insert(h[i] + 1);
        }
        if (ubound.contains(h[i]))
            ubound[h[i]] = min(ubound[h[i]], p[i] - h[i]);
        else
            ubound[h[i]] = p[i] - h[i];
        pts.insert(h[i]);
    }

    int cur_mxr = 0;
    for (auto& [h, r] : mxr) {
        //cout << mxr[h] << ' ';
        cur_mxr = max(cur_mxr, r);
        lbound[h] = max(0, cur_mxr - h);
    }
    //cout << '\n';

    /*cout << "lbound: ";
    for (int i = 0; i < H; i++)
        cout << lbound[i] << ' ';
    cout << '\n';
    cout << "ubound: ";
    for (int i = 0; i < H; i++)
        cout << ubound[i] << ' ';
    cout << '\n';*/

    /*for (auto& [h, b] : lbound)
        cout << h << "-" << b << " ";
    cout << "\n";*/

    int ans = 0;
    for (int h : pts) {
        //cout << h << ' ' << lbound[h] << ' ' << ubound[h] << '\n';
        if (lbound.contains(h))
            ans = max(ans, lbound[h]);
        if (ubound.contains(h) && ans > ubound[h]) {
            cout << -1 << '\n'; return;
        }
    }
    cout << ans << '\n';
}

int main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
