#define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
//namespace r = ranges;
//namespace v = views;

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#ifdef LOCAL
//#include "debug.h"
#else
#define debug(...) 533
#endif

template <typename K, typename V, template <typename> typename Comp = less> using ordered_map = tree<K, V, Comp<K>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T, template <typename> typename Comp = less> using ordered_set = ordered_map<T, null_type, Comp>;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
template<typename T> T random(T l, T r) { return uniform_int_distribution<T>(l, r)(rng); }

const ll mod = 1'000'000'009;

template<typename T, const T MOD>
struct modint {
    T val;
    modint(const T x = 0) {
        val = x % MOD;
        if (val < 0) val += MOD;
    }
    [[nodiscard]] modint binpow(modint x, T p) const {
        auto res = modint(1);
        while (p) {
            if (p & 1) res *= x;
            x *= x;
            p >>= 1;
        }
        return res;
    }
    [[nodiscard]] modint inv() const {
        return binpow(*this, MOD - 2);
    }
    modint operator+(const modint &x) const { return {val + x.val < MOD ? val + x.val : val + x.val - MOD}; }
    modint operator-(const modint &x) const { return {val - x.val < 0 ? val - x.val + MOD : val - x.val}; }
    modint operator*(const modint &x) const { return {(val * x.val) % MOD}; }
    modint operator/(const modint &x) const { return {(val * x.inv().val) % MOD}; }
    modint operator+=(const modint &x) { return *this = *this + x; }
    modint operator-=(const modint &x) { return *this = *this - x; }
    modint operator*=(const modint &x) { return *this = *this * x; }
    modint operator/=(const modint &x) { return *this = *this / x; }
    modint operator^(const modint &x) const { return binpow(*this, x.val); }
    bool operator==(const modint &x) const { return val == x.val; }
    bool operator!=(const modint &x) const { return val != x.val; }

    friend istream& operator>> (istream &in, modint &d) { return in >> d.val; }
    friend ostream& operator<< (ostream &out, const modint &d) { return out << d.val; }
};

typedef modint<ll, mod> mint;

void solve(istream &cin = std::cin, ostream &cout = std::cout) {
    int n;
    cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    ll result = 0;
    for (int rem = 0; rem < 3; ++rem) {
        mint b = 0;
        mint coef = 1;
        for (int i = 0; i < n; ++i) {
            b += coef * (a[n - i - 1] - rem);
            coef *= mint(-2);
        }
        mint c = mint(1) - coef;
        ll k = (b * c.inv()).val;
        ll k0 = k;
        ll smallest_k = k;
        vector<ll> sub(a.begin(), a.end());
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            sub[i] -= k * 2 + rem;
            if (sub[i] < 0) { ok = false; break; }
            k = sub[i];
            smallest_k = min(smallest_k, k);
        }
        if (k != k0) ok = false;
        if (ok) {
            result = max(result, rem + smallest_k * 3);
        }
    }
    cout << result << "\n";
}
/*

*/
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int test = 1;
#if LOCAL
    ifstream cin("../kolya.in"); // ofstream cout("../kolya.out");
    cin >> test;
    if (test == 0) cerr << "CHANGE .IN FILE" << endl;
    for (int i = 1; i <= test; i++) {
        const auto divider = string(30, '=');
        cout << divider << ' ' << i << ' ' << divider << '\n';
        solve(cin, cout);
        cout << '\n';
    }
#else
    // ifstream cin(".in"); ofstream cout(".out");
    cin >> test;
    for (int i = 0; i < test; i++) {
        solve(cin, cout);
    }
#endif
}