#define _GLIBCXX_DEBUG 1
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
//namespace r = ranges;
//namespace v = views;

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#ifdef LOCAL
//#include "debug.h"
#else
#define debug(...) 533
#endif

template <typename K, typename V, template <typename> typename Comp = less> using ordered_map = tree<K, V, Comp<K>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T, template <typename> typename Comp = less> using ordered_set = ordered_map<T, null_type, Comp>;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
template<typename T> T random(T l, T r) { return uniform_int_distribution<T>(l, r)(rng); }

const int mod = 1'000'000'007;

bool check_draw(vector<ll> &xr, vector<ll> &xb, vector<ll> &mr, vector<ll> &mb) {
    return !xr.empty() && !xb.empty() && xr.back() < xb.back();
}

void destroy(vector<ll> &xr, vector<ll> &xb, vector<ll> &mr, vector<ll> &mb) {
    if (xr.back() == xb.back()) {
        ll m = min(mr.back(), mb.back());
        mr.back() -= m;
        mb.back() -= m;
        while (!mr.empty() && mr.back() == 0) {
            mr.pop_back();
            xr.pop_back();
        }
        while (!mb.empty() && mb.back() == 0) {
            mb.pop_back();
            xb.pop_back();
        }
    }
}

void print(vector<ll> &xr, vector<ll> &xb, vector<ll> &mr, vector<ll> &mb) {
    cout << "xr ";
    for (auto &e : xr) cout << e << ' ';
    cout << endl;
    cout << "xb ";
    for (auto &e : xb) cout << e << ' ';
    cout << endl;
    cout << "mr ";
    for (auto &e : mr) cout << e << ' ';
    cout << endl;
    cout << "mb ";
    for (auto &e : mb) cout << e << ' ';
    cout << endl << endl;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout) {
    int n;
    cin >> n;
    vector<ll> x(n), m(n), xr{}, xb{}, mr{}, mb{};
    vector<char> c(n);
    ll sumr = 0, sumb = 0;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> m[i] >> c[i];
        if (c[i] == 'R') {
            sumr += m[i];
        } else {
            sumb += m[i];
        }
        if (c[i] == 'R') {
            xr.push_back(x[i]);
            mr.push_back(m[i]);
        } else {
            xb.push_back(x[i]);
            mb.push_back(m[i]);
        }
    }
    ll ptr = xr.back();
    bool f = sumr > sumb;
    if (sumr == sumb) {
        cout << "Draw 0 0\n";
        return;
    }
    if (f) {
        xr.push_back(xr.back() + 1);
        mr.back() -= 1;
        mr.push_back(1);
        destroy(xr, xb, mr, mb);
    } else {
        swap(xr, xb);
        swap(mr, mb);
    }
    while (1) {
        if (check_draw(xr, xb, mr, mb)) {
            cout << "Draw " << ptr << ' ' << '+';
            return;
        }
        if (xr.empty() || xb.empty()) {
            cout << (f ?  "First " : "Second");
            if (f) cout << ptr << ' ' << '+';
            cout << '\n';
            return;
        }
        ll m = min(mb.back(), mr.back());
        ll time = m * (xr.back() - xb.back());
        xb.push_back(xr.back());
        mb.back() -= m;
        mb.push_back(m);
        // print(xr, xb, mr, mb);

        destroy(xr, xb, mr, mb);
        // cout << m << ' ' << time << endl;
        // print(xr, xb, mr, mb);
        if (xb.empty()) {
            continue;
        }
        while (time > 0) {
            if (xb.back() - xr.back() < 0) break;
            ll d = min(time / (xb.back() - xr.back()), mr.back());
            if (d == 0) break;
            time -= d * (xb.back() - xr.back());
            xr.push_back(xb.back());
            mr.back() -= d;
            mr.push_back(d);
            destroy(xr, xb, mr, mb);
            // print(xr, xb, mr, mb);
        }
        xr.push_back(xr.back() + time);
        mr.back() -= 1;
        mr.push_back(1);
    }
}
/*

*/
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int test = 1;
#if LOCAL
    ifstream cin("../andrew.in"); // ofstream cout("../danya.out");
    cin >> test;
    if (test == 0) cerr << "CHANGE .IN FILE" << endl;
    for (int i = 1; i <= test; i++) {
        const auto divider = string(30, '=');
        cout << divider << ' ' << i << ' ' << divider << '\n';
        solve(cin, cout);
        cout << '\n';
    }
#else
    // ifstream cin(".in"); ofstream cout(".out");
    cin >> test;
    for (int i = 0; i < test; i++) {
        solve(cin, cout);
    }
#endif
}