//// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
////
//
//#include <iostream>
//#include <vector>
//#include <algorithm>
//#include <utility>
//#include <string>
//#include <map>
//#include <set>
//using namespace std;
//
//#define ll long long
//
//int main()
//{
//	int n, e;
//
//	cin >> n >> e;
//
//	set<char> unique_symbols;
//	vector<string> Ls(n);
//	for (auto i = 0; i < n; ++i)
//	{
//		cin >> Ls[i];
//
//		for (size_t k = 0; k < Ls[i].size(); ++k)
//			unique_symbols.insert(Ls[i][k]);
//	}
//
//	if (unique_symbols.size() < e)
//	{
//		for (auto letter = 'a'; letter <= /*'a' + e - 1*/ 'z'; ++letter)
//			if (!unique_symbols.count(letter))
//			{
//				cout << letter;
//				return 0;
//			}
//	}
//
//	set<char> unique_first_symbols;
//	for (auto const& L : Ls)
//		unique_first_symbols.insert(L.front());
//
//	if (unique_first_symbols.size() < e)
//	{
//		for (auto letter = 'a'; letter <= 'z'; ++letter)
//			if (!unique_first_symbols.count(letter))
//			{
//				cout << letter;
//				return 0;
//			}
//	}
//
//	map<char, ll> first_sym_counts;
//	for (auto const& L : Ls)
//	{
//		char first_sym = L.front();
//
//		if (first_sym_counts.count(first_sym) && first_sym_counts[first_sym] == -1)
//			continue;
//
//		first_sym_counts[first_sym]++;
//		
//		if (L.size() == 1)
//			first_sym_counts[first_sym] = -1;
//		
//		for (size_t i = 1; i < L.size() && first_sym == L[i]; ++i)
//		{
//			first_sym_counts[first_sym]++;
//			if (i == L.size() - 1)
//				first_sym_counts[first_sym] = -1;
//		}
//	}
//
//	ll min_result{ -1 };
//	char result;
//
//	for (auto const& item : first_sym_counts)
//	{
//		if (item.second > 0)
//		{
//			if (min_result == -1)
//			{
//				result = item.first;
//				min_result = item.second;
//			}
//			else
//			{
//				result = item.first;
//				min_result = min(min_result, item.second);
//			}
//		}
//	}
//
//	if (min_result != -1)
//	{
//		for (auto i = 0; i < min_result + 1; ++i)
//			cout << result;
//	}
//	else
//		cout << "NO";
//}


#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <map>
using namespace std;

#define ll long long

int main()
{
	ll t, n;
	cin >> t;

	for (auto i = 0; i < t; ++i)
	{
		cin >> n;

		vector<ll> current_h(n);
		vector<ll> past_h(n);
		vector<char> curr_diffes(current_h.size() - 1);
		vector<char> past_diffes(past_h.size() - 1);
		multimap<ll, size_t> past_orders;

		for (size_t k = 0; k < n; ++k)
			cin >> current_h[k];

		for (size_t k = 0; k < n; ++k)
		{
			cin >> past_h[k];
			past_orders.insert({ past_h[k], k });
		}

		for (size_t k = 0; k < curr_diffes.size(); ++k)
			curr_diffes[k] = current_h[k] - current_h[k + 1] >= 0 ? '+' : '-';

		for (size_t k = 0; k < past_diffes.size(); ++k)
		{
			past_diffes[k] = past_h[k] - past_h[k + 1] >= 0 ? '+' : '-';

			if (curr_diffes[k] != past_diffes[k])
			{
				cout << -1;
				return 0;
			}
		}

		ll max_diff{ -1 };

		ll pred_diff{ 1000001 };

		map<ll, ll> past_height_cur_height_;

		for (auto iter = past_orders.rbegin(); iter != past_orders.rend(); ++iter)
		{
			ll diff = past_h[iter->second] - current_h[iter->second];

			if (past_height_cur_height_.count(iter->first))
			{
				if (current_h[iter->second] != past_height_cur_height_[iter->first])
				{
					max_diff = -1;
					break;
				}
			}
			else
			{
				past_height_cur_height_[iter->first] = current_h[iter->second];
			}

			if (diff > pred_diff)
			{
				max_diff = -1;
				break;
			}

			pred_diff = diff;

			if (diff < 0)
			{
				max_diff = -1;
				break;
			}

			max_diff = max(max_diff, diff);
		}

		cout << max_diff << endl;
	}
}