#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

bool gambare(vector<ll> &a, vector<ll> &b) {
    for (int i = 0; i < a.size() - 1; ++i) {
        a[i + 1] += a[i] / 2ll;
        a[i] %= 2ll;
        b[i + 1] += b[i] / 2ll;
        b[i] %= 2ll;
        if (a[i] >= 2 || b[i] >= 2 || a[i] < 0 || b[i] < 0) {
            throw runtime_error("Unexpected");
        }
    }
    for (int i = a.size() - 1; i >= 0; --i) {
        if (a[i] == b[i]) {
            continue;
        }
        if (a[i] < b[i]) {
            return false;
        } else {
            return true;
        }
    }
    return true;
}

bool equals(vector<ll> &a, vector<ll> &b) {
    for (int i = 0; i < a.size() - 1; ++i) {
        a[i + 1] += a[i] / 2ll;
        a[i] %= 2ll;
        b[i + 1] += b[i] / 2ll;
        b[i] %= 2ll;
        if (a[i] >= 2 || b[i] >= 2) {
            throw runtime_error("Unexpected");
        }

        if (a[i] != b[i]) {
            return false;
        }
    }
    return a[a.size() - 1] == b[b.size() - 1];
}

void remove(vector<ll> &adder, vector<ll> &remover, vector<ll> &result) {
    for (int i = 0; i < adder.size() - 1; ++i) {
        adder[i + 1] += adder[i] / 2ll;
        adder[i] %= 2ll;
        remover[i + 1] += remover[i] / 2ll;
        remover[i] %= 2ll;
        if (adder[i] >= 2 || remover[i] >= 2) {
            throw runtime_error("Unexpected");
        }
    }
    for (int i = 0; i < adder.size(); ++i) {
       if (adder[i] >= remover[i]) {
           result[i] = adder[i] - remover[i];
           continue;
       }
       for (int j = i; j < adder.size(); ++j) {
           if (adder[j] >= 1) {
               adder[j]--;
               for (int k = j - 1; k >= i; k--) {
                   adder[k]++;
               }
               adder[i]++;
               break;
           }
           if (j + 1 == adder.size()) {
               result.clear();
               result.resize(adder.size(), 0);
               remove(remover, adder, result);
               return;
           }
       }
       result[i] = 1;
    }
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        int n;
        cin >> n;
        vector<ll> k(n);
        for (int j = 0; j < n; ++j) {
            cin >> k[j];
        }
        ll best_ans = 0;
        for (int ans = 1; ans < 4; ++ans) {
            vector<ll> adder(n + 100, 0), remover(n + 100, 0), result(n + 100, 0);
            bool need_break = false;
            for (int l = 0; l < n; ++l) {
                if (--k[l] < 0) {
                    need_break = true;
                }
            }
            if (need_break) {
                break;
            }
            for (int idx = n - 1; idx >= 0; idx -= 2) {
                adder[n - 1 - idx] += k[idx];
            }
            for (int idx = n - 2; idx >= 0; idx -= 2) {
                remover[n - 1 - idx] += k[idx];
            }
            if (!equals(adder, remover) && gambare(adder, remover) && n % 2 == 0) {
                continue;
            }
            if (!equals(adder, remover) && !gambare(adder, remover) && n % 2 == 1) {
                continue;
            }
            remove(adder, remover, result);
//            cout << "RESULT\n";
//            for (int i = 0; i < 10; ++i) {
//                cout << result[i] << ' ';
//            }
//            cout << '\n';
            ll l = -1, r = 2e9;
            ll c0 = -1;
            while (r - l > 1ll) {
                ll m = (l + r) / 2ll;
                vector<ll> koef(n + 100, 0);
                if (n % 2 == 0) {
                    for (int idx = 0; idx < n; ++idx) {
                        koef[idx] = m;
                    }
                } else {
                    koef[n] = m;
                    koef[0] = m;
                }
                if (equals(result, koef)) {
                    c0 = m;
                    // cout << "FOUND: " << c0 << '\n';
                    break;
                }
                if (gambare(result, koef)) {
                    l = m;
                } else {
                    r = m;
                }
            }
            if (c0 == -1) {
                continue;
            }
            ll min_c = c0;
            ll c_last = c0;
            for (int j = 0; j + 1 < k.size(); ++j) {
                c_last = k[j] - 2 * c_last;
                min_c = min(min_c, c_last);
                if (min_c < 0) {
                    break;
                }
            }
            if (min_c < 0) {
                continue;
            }
            best_ans = max(best_ans, ans + 3ll * min_c);
        }
        cout << best_ans << '\n';
    }
    return 0;
}
