#include <bits/stdc++.h>
// #pragma comment(linker, "/STACK:16777216")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,sse4,fma,bmi,bmi2,popcnt,lzcnt,abm,tune=native")

using namespace std;
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
using dbl = double;
using ld = long double;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<dbl, dbl>;
using pld = pair<ld, ld>;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ft first
#define sc second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

void dfs_topsort(int v, vector<vector<int>> &g, vector<bool> &used, vector<int> &order) {
    used[v] = true;
    for (auto to: g[v])
        if (!used[to])
            dfs_topsort(to, g, used, order);
    order.pb(v);
}

void dfs_comp(int v, vector<vector<int>> &g, vector<int> &comp, vector<int> &comp_vec, int comp_number) {
    comp[v] = comp_number;
    comp_vec.pb(v);
    for (auto to: g[v])
        if (comp[to] == -1) {
            dfs_comp(to, g, comp, comp_vec, comp_number);
        }
}

vector<int> solve(int n, int m) {
//    int n, m;
//    cin >> n >> m;
    vector<vector<int>> g(n), revg(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[--a].pb(--b);
        revg[b].pb(a);
    }
//    for (int i = 0; i < n; i++) for (auto to: g[i]) revg[to].pb(i);
    vector<bool> used(n, false);
    vector<int> order;
    for (int i = 0; i < n; i++) { if (!used[i]) dfs_topsort(i, g, used, order); }
    vector<int> comp(n, -1);
    vector<vector<int>> components;
    int comp_number = 0;
    reverse(all(order));
    for (auto v: order) {
        if (comp[v] == -1) {
            vector<int> comp_vec;
            dfs_comp(v, revg, comp, comp_vec, comp_number++);
            components.push_back(comp_vec);
        }
    }
    vector<int> out_degree(n, 0);
    for (int v = 0; v < n; v++) {
        for (auto to: g[v]) {
            if (comp[v] == comp[to]) {
                out_degree[v]++;
            }
        }
    }
    vector<vector<int>> comp_ordering;
    used.assign(n, false);
    for (const auto &comps: components) {
        vector<int> ordering;
        set<pi, std::greater<>> st;
        for (auto v: comps) st.insert({out_degree[v], v});
        while (!st.empty()) {
            int v = st.begin()->second;
            used[v] = true;
            ordering.push_back(v);
            st.erase(st.begin());
            for (auto to: revg[v]) {
                if (comp[to] == comp[v] && !used[to]) {
                    st.erase({out_degree[to], to});
                    out_degree[to]--;
                    st.insert({out_degree[to], to});
                }
            }
        }
        comp_ordering.pb(ordering);
    }
    vector<vector<int>> css(comp_number);
    for (int v = 0; v < n; v++) {
        for (auto to: g[v])
            if (comp[to] != comp[v])
                css[comp[v]].pb(comp[to]);
    }
    used.assign(comp_number, false);
    order.clear();
    for (int v = 0; v < comp_number; v++) {
        if (!used[v]) {
            dfs_topsort(v, css, used, order);
        }
    }
    reverse(all(order));
    vector<bool> comps_used(comp_number, false);
    vector<int> out;
    for (auto v: order) {
        if (!comps_used[v]) {
            comps_used[v] = true;
            for (auto x: comp_ordering[v]) {
                out.pb(x);
            }
        }
    }
    for (auto x: out) cout << x + 1 << " ";
    cout << "\n";
    return out;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("", "r", stdin);
    // freopen("", "w", stdout);

//    {
//        mt19937 rnd(42);
//        for (int i = 0; i < 20000; i++) {
//            int n = rnd() % 20 + 2;
//            int m = rnd() % (2 * n) + 1;
//            vector<vector<int>> g(n);
//            set<pi> st;
//            for (int i = 0; i < m; i++) {
//                int a = rnd() % n;
//                int b = rnd() % n;
//                while (b == a || st.count({a, b})) b = rnd() % n;
//                st.insert({a, b});
//                g[a].pb(b);
//            }
//            vector<int> res = solve(n, m, g);
//            int cnt = 0;
//            for (int v = 0; v < n; v++)
//                for (auto to: g[v]) {
//                    bool ok = false;
//                    for (auto x: res) {
//                        if (x == v) {
//                            ok = true;
//                            break;
//                        } else if (x == to) {
//                            break;
//                        }
//                    }
//                    cnt += ok;
//                }
//            if (cnt < (m + 1) / 2) {
//                cout << "Wrong!";
//                cout << n << " " << m << "\n";
//                for (int i = 0; i < n; i++) {
//                    for (auto to: g[i]) {
//                        cout << i << " " << to << "\n";
//                    }
//                }
//                for (auto x: res) cout << x << " ";
//                cout << "\n";
//                break;
//            }
//        }
//    }


    int t = 1;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        solve(n, m);
    }
    return 0;
}