
#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <iomanip>
#include <string>
#include <random>
#include <typeinfo>
#include <map>
#include <set>
#include <cassert>
#include <queue>
#include <unordered_set>
#include <cstddef>
#include <unordered_map>
#include <array>
#include <ranges>

// #pragma GCC optimize("Ofast,unroll-loops")
// #pragma GCC target("avx2,popcnt,lzcnt,abm,bmi,bmi2")

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#ifdef DUDE
#define debug(x) cerr << #x << ": " << x << endl
#define debugvec(x) ({cerr << #x << ":\n"; for (const auto& e :x) cerr << '\t' << e << '\n';})
#else
#define debug(x) ;
#define debugvec(x) ;
#endif

using std::cout;
using std::cin;
using std::cerr;
using std::endl;
using std::ostream;
using std::istream;
using std::vector;
using std::pair;
using std::string;
using std::array;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;
std::mt19937 rnd(1488);

template<typename T>
istream &operator>>(istream &in, vector<T> &vec) {
    for (size_t i = 0; i < vec.size(); ++i) {
        in >> vec[i];
    }
    return in;
}

ostream &operator<<(ostream &out, const vector<bool> &vec) {
    for (bool i: vec) {
        if (i)
            out << '1';
        else
            out << '0';
    }
    return out;
}

template<typename T, typename U>
ostream &operator<<(ostream &out, const pair<T, U> &p) {
    out << p.first << ' ' << p.second;
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &vec) {
    char end_char = '\n';
    if constexpr (std::is_arithmetic_v<T>)
        end_char = ' ';
    for (const T &e: vec)
        out << e << end_char;
    return out;
}

template<typename T, size_t sz>
ostream &operator<<(ostream &out, const array<T, sz> &arr) {
    char end_char = '\n';
    if constexpr (std::is_arithmetic_v<T>)
        end_char = ' ';
    for (const T &e: arr)
        out << e << end_char;
    return out;
}

template<typename T>
bool mini(T &a, const T &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool maxi(T &a, const T &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */

const int mod = 998'244'353;

struct int_mod {
    int x;

    int_mod() = default;

    int_mod(int x_) : x(x_) {};
};

int_mod operator+(int_mod a, int_mod b) {
    int r = a.x + b.x;
    if (r < mod) return {r};
    return {r - mod};
}

int_mod operator*(int_mod a, int_mod b) {
    return {static_cast<int>((1ll * a.x * b.x) % mod)};
}

int_mod operator*(int_mod a, int b) {
    return {static_cast<int>((1ll * a.x * b) % mod)};
}

int_mod operator-(int_mod a, int_mod b) {
    int r = a.x - b.x;
    if (r < 0) return {r + mod};
    return {r};
}

int_mod &operator+=(int_mod &a, int_mod b) {
    a.x = (a.x + b.x) % mod;
    return a;
}

bool operator==(int_mod a, int_mod b) {
    return a.x == b.x;
}

ostream &operator<<(ostream &out, const int_mod &x) {
    out << x.x;
    return out;
}

int_mod calc_dp(const vector<int> &to_use, int need, int n, int sz) {
    int_mod dp[n + 1][(1 << sz)][2];

    bool ok[(1 << sz)][2];
    for (int i = 0; i < (1 << sz); i++) ok[i][0] = ok[i][1] = false;
    for (auto i: to_use) {
        ok[i / 2][i % 2] = true;
    }

    for (int i = 0; i <= n; i++) for (int j = 0; j < (1 << sz); j++) dp[i][j][0] = dp[i][j][1] = 0;

    if (n < sz) return 0;
    if (n == sz) {
        return 1;
    }
    for (int i = 0; i < (1 << sz); i++) {
        dp[sz][i][(i == need)] = 1;
    }
    for (int i = sz; i < n; i++) {
        for (int j = 0; j < (1 << sz); j++) {
            { // от dp[i][j][0]
                if (ok[j][0]) {
                    int nxt_j = (j * 2) % (1 << sz);
                    if (nxt_j == need) {
                        dp[i + 1][nxt_j][1] += dp[i][j][0];
                    } else {
                        dp[i + 1][nxt_j][0] += dp[i][j][0];
                    }
                }
                if (ok[j][1]) {
                    int nxt_j = (j * 2 + 1) % (1 << sz);
                    if (nxt_j == need) {
                        dp[i + 1][nxt_j][1] += dp[i][j][0];
                    } else {
                        dp[i + 1][nxt_j][0] += dp[i][j][0];
                    }
                }
            }
            { // dp[i][j][1]
                if (ok[j][0]) {
                    int nxt_j = (j * 2) % (1 << sz);
                    dp[i + 1][nxt_j][1] += dp[i][j][1];
                }
                if (ok[j][1]) {
                    int nxt_j = (j * 2 + 1) % (1 << sz);
                    dp[i + 1][nxt_j][1] += dp[i][j][1];
                }
            }
        }
    }
    int_mod z = 0;
    for (int i = 0; i < (1 << sz); i++) z += dp[n][i][1];
    return z;
}

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    string w;
    cin >> w;
    int need = 0;
    for (int i = 0; i < w.size(); ++i) {
        need += (w[i] - '0') * (1 << (w.size() - i - 1));
    }
    int cnt_s = 1 << (k + 1);
    int_mod F[1 << cnt_s][2];
    int_mod S[1 << cnt_s][2];
    F[0][0] = F[0][1] = 0;
    S[0][0] = S[0][1] = 0;
//    int_mod f_n[1 << cnt_s];
//    int_mod f_m[1 << cnt_s];
    int sizes[] = {n, m};
    for (int it = 0; it < 2; ++it) {
        for (uint mask = 1; mask < (1 << cnt_s); ++mask) {
            vector<int> set;
            int fst = -1, lst = -1;
            for (int i = 0; i < cnt_s; ++i) {
                if ((mask & (1 << i)) == 0) {
                    continue;
                }
                if (fst == -1) {
                    fst = i;
                }
                lst = i;
                set.push_back(i);
            }
            fst = 1 << fst;
            lst = 1 << lst;
            int_mod f = calc_dp(set, need, sizes[it], k);
            if (lst == fst) {
                S[mask][it] = 0;
            } else {
                S[mask][it] = S[mask ^ fst][it] +
                              S[mask ^ lst][it] -
                              S[mask ^ (lst | fst)][it] +
                              F[mask ^ fst][it] +
                              F[mask ^ lst][it] -
                              F[mask ^ (lst | fst)][it];
            }
            F[mask][it] = f - S[mask][it];
        }
    }
    int_mod ans = 0;
    for (int mask = 1; mask < (1 << cnt_s); ++mask) {
        for (int submask = mask; submask > 0; submask = (submask - 1) & mask) {
            int mask0 = mask ^ submask;
            int mask1 = submask;
            ans += F[mask0][0] * F[mask1][1];
        }
    }
    cout << ans;

}

signed main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef DUDE
    freopen("./../inputf.in", "r", stdin);
    freopen("./../outputf.out", "w", stdout);
#endif

    // stress();

//#define DUDE
    int test = 1;
#ifdef DUDE
    cin >> test;
#endif
    while (test--) {
        solve();
        cout << '\n';
    }
    return 0;
};